=== debian/changelog ===
rock-master-19.06-planning-fast-downward (0.20190705-1~stretch) unstable; urgency=low

  * Package automatically built using 'apaka'
  * url: http://hg.fast-downward.org/archive/4d52652adfee.tar.gz/src
  * filename: fastdownward-4d52652adfee.tar.gz

 -- Packaging Daemon <rock-dev@dfki.de>  Mon, 08 Jul 2019 16:13:32 +0200
