=== debian/control ===
Source: rock-master-19.06-planning-fast-downward
Section: science
Priority: extra
Maintainer: Rock Packaging Daemon <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, build-essential, cmake, gawk, python-dev, rock-master-19.06-base-cmake
Standards-Version: 3.9.2
Homepage: http://rock-robotics.org
#Vcs-Git: git://git.debian.org/collab-maint/bla.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/bla.git;a=summary

Package: rock-master-19.06-planning-fast-downward
Architecture: any
Depends: ${shlibs:Depends}, rock-master-19.06-base-cmake, cmake, build-essential, gawk, python-dev
Description: FastDownward
 This in an integration package for FastDownward. It can be used with aliases to run planner configurations as used in the IPC 2014 planning competition.
  No additional functionality is provided and benchmarks and experiments are stripped from the original archive. Adaptation to the original sources are made solely to facilicate integration of the planner into the build infrastructure.
